Index: ip_fw2.c
===================================================================
RCS file: /home/ncvs/src/sys/netinet/ip_fw2.c,v
retrieving revision 1.49
diff -u -p -r1.49 ip_fw2.c
--- ip_fw2.c	24 Nov 2003 03:57:03 -0000	1.49
+++ ip_fw2.c	26 Nov 2003 18:11:10 -0000
@@ -453,27 +453,33 @@ iface_match(struct ifnet *ifp, ipfw_insn
 static int
 verify_rev_path(struct in_addr src, struct ifnet *ifp)
 {
-	static struct route ro;
+	struct route ro;
 	struct sockaddr_in *dst;
 
 	dst = (struct sockaddr_in *)&(ro.ro_dst);
 
-	/* Check if we've cached the route from the previous call. */
-	if (src.s_addr != dst->sin_addr.s_addr) {
-		ro.ro_rt = NULL;
+	ro.ro_rt = NULL;
+	bzero(dst, sizeof(*dst));
+	dst->sin_family = AF_INET;
+	dst->sin_len = sizeof(*dst);
+	dst->sin_addr = src;
+	rtalloc_ign(&ro, RTF_CLONING);
 
-		bzero(dst, sizeof(*dst));
-		dst->sin_family = AF_INET;
-		dst->sin_len = sizeof(*dst);
-		dst->sin_addr = src;
-
-		rtalloc_ign(&ro, RTF_CLONING);
+	if (ro.ro_rt == NULL) {
+		printf("ip_fw2.c:verrevpath: No route to src %s found\n",
+		       inet_ntoa(src));
+		return 0;
 	}
-
-	if (ro.ro_rt == NULL)
+	if (ifp == NULL) {
+		RTFREE(ro.ro_rt);
+		printf("ip_fw2.c:verrevpath: ifp == NULL in route to src %s\n",
+		       inet_ntoa(src));
 		return 0;
-	if ((ifp == NULL) || (ro.ro_rt->rt_ifp->if_index != ifp->if_index)) {
+	}
+	if (ro.ro_rt->rt_ifp->if_index != ifp->if_index) {
 		RTFREE(ro.ro_rt);
+		printf("ip_fw2.c:verrevpath: pkt.ifp != ro.ifp in route to src %s\n",
+		       inet_ntoa(src));
 		return 0;
 	}
 	RTFREE(ro.ro_rt);
